var n = /* @__PURE__ */ ((t) => (t.SINGLE_NODE = "SINGLE_NODE", t.COLLECTION_NODE = "COLLECTION_NODE", t.QUEUE_NODE = "QUEUE_NODE", t.GROUPED_LIST_NODE = "GROUPED_LIST_NODE", t))(n || {});
const U = {
  people: "person"
}, A = (t) => U[t] ? U[t] : /[a-z]+oes$/.test(t) ? t.replace(/oes$/, "o") : /[a-z]+ies$/.test(t) ? t.replace(/ies$/, "y") : /[a-z]+es$/.test(t) ? t.replace(/es$/, "") : /[a-z]+s$/.test(t) ? t.replace(/s$/, "") : t, c = (t) => A(t).toUpperCase(), I = (t) => Array.isArray(t), S = (t) => {
  if (typeof t != "object")
    return !1;
  const e = Object.keys(t).pop();
  return t && t[e] && t[e].id === e;
}, L = (t) => {
  if (typeof t != "object")
    return !1;
  const e = Object.keys(t).pop(), r = e ? t[e] : null, { items: s } = r != null ? r : {};
  return S(t) && Array.isArray(s);
}, g = (t) => typeof t != "object" ? !1 : !t.id, i = (t) => {
  if (I(t))
    return n.QUEUE_NODE;
  if (L(t))
    return n.GROUPED_LIST_NODE;
  if (S(t))
    return n.COLLECTION_NODE;
  if (g(t))
    return n.SINGLE_NODE;
}, $t = (t) => {
  const e = {};
  return Object.keys(t).reduce((r, s) => (i(t[s]) && (r[s] = i(t[s])), r), e);
}, Ut = (t, e) => Object.keys(t).filter((r) => !e.includes(r)).reduce((r, s) => (r[s] = t[s], r), {}), O = (t) => ({
  get: `GET_${t.toUpperCase()}`,
  setAll: `SET_${t.toUpperCase()}`,
  patch: `PATCH_${t.toUpperCase()}`
}), M = (t) => ({
  get: `GET_${t.toUpperCase()}`,
  setAll: `SET_${t.toUpperCase()}`,
  push: `PUSH_${c(t)}`,
  pop: `POP_${c(t)}`,
  clear: `CLEAR_${t.toUpperCase()}`
}), P = (t) => ({
  get: `GET_${t.toUpperCase()}`,
  setAll: `SET_${t.toUpperCase()}`,
  set: `SET_${c(t)}`,
  add: `ADD_${c(t)}`,
  patch: `PATCH_${c(t)}`,
  delete: `DELETE_${c(t)}`
}), D = (t) => ({
  get: `GET_${t.toUpperCase()}`,
  setAll: `SET_${t.toUpperCase()}`,
  set: `SET_${c(t)}`,
  add: `ADD_${c(t)}`,
  patch: `PATCH_${c(t)}`,
  delete: `DELETE_${c(t)}`,
  getItems: `GET_${t.toUpperCase()}_ITEMS`,
  setItems: `SET_${t.toUpperCase()}_ITEMS`,
  pushItem: `PUSH_${t.toUpperCase()}_ITEM`,
  popItem: `POP_${t.toUpperCase()}_ITEM`,
  deleteItem: `DELETE_${t.toUpperCase()}_ITEM`,
  patchItem: `PATCH_${t.toUpperCase()}_ITEM`,
  clearItems: `CLEAR_${t.toUpperCase()}_ITEMS`,
  pushManyItems: `PUSH_MANY_${t.toUpperCase()}_ITEMS`
}), f = (t) => {
  let e = {};
  const r = Object.keys(t);
  for (const s of r) {
    const p = t[s];
    switch (i(p)) {
      case n.SINGLE_NODE:
        e[s] = O(String(s));
        break;
      case n.QUEUE_NODE:
        e[s] = M(String(s));
        break;
      case n.COLLECTION_NODE:
        e[s] = P(String(s));
        break;
      case n.GROUPED_LIST_NODE:
        e[s] = D(String(s));
        break;
    }
  }
  return e;
}, h = ["get"], H = [
  "setAll",
  "set",
  "setMany",
  "pushMany",
  "setItems",
  "pushManyItems"
], St = (t) => {
  let e = {};
  const r = f(t), s = Object.keys(r);
  for (const p of s) {
    const _ = r[p];
    Object.keys(_).forEach((o) => {
      const E = _[o];
      e[E] = {
        id: E,
        verb: o,
        nodeName: p
      }, H.includes(o) && (e[E].isLocal = !0), h.includes(o) && (e[E].isGet = !0);
    });
  }
  return e;
}, T = {
  "@@redux-store-generator/AUTO_GENERATED_ACTION": !0
}, G = (t, e) => (r) => ({
  type: `PATCH_${t.toUpperCase()}`,
  payload: r,
  ...e
}), k = (t, e) => (r) => ({
  type: `SET_${t.toUpperCase()}`,
  payload: r,
  ...e
}), b = (t, e) => () => ({
  type: `GET_${t.toUpperCase()}`,
  ...e
}), R = (t, e) => ({
  get: b(t, e),
  setAll: k(t, e),
  patch: G(t, e)
}), w = (t, e) => (r = {}) => ({
  type: `GET_${t.toUpperCase()}`,
  payload: r,
  ...e
}), Y = (t, e) => (r) => ({
  type: `SET_${t.toUpperCase()}`,
  payload: r,
  ...e
}), d = (t, e) => (r) => ({
  type: `PUSH_${c(t)}`,
  payload: r,
  ...e
}), j = (t, e) => (r) => ({
  type: `PUSH_MANY_${t.toUpperCase()}`,
  payload: {
    items: r
  },
  ...e
}), q = (t, e) => () => ({
  type: `POP_${c(t)}`,
  ...e
}), Q = (t, e) => () => ({
  type: `CLEAR_${t.toUpperCase()}`,
  ...e
}), z = (t, e) => ({
  get: w(t, e),
  setAll: Y(t, e),
  push: d(t, e),
  pop: q(t, e),
  clear: Q(t, e),
  pushMany: j(t, e)
}), F = (t, e) => (r = {}) => ({
  type: `GET_${t.toUpperCase()}`,
  payload: r,
  ...e
}), K = (t, e) => (r) => ({
  type: `SET_${t.toUpperCase()}`,
  payload: r,
  ...e
}), B = (t, e) => (r) => ({
  type: `ADD_${c(t)}`,
  payload: {
    ...r
  },
  ...e
}), J = (t, e) => (r, s) => ({
  type: `SET_${c(t)}`,
  id: r,
  payload: {
    ...s
  },
  ...e
}), X = (t, e) => (r, s) => ({
  type: `PATCH_${c(t)}`,
  id: r,
  payload: {
    ...s
  },
  ...e
}), Z = (t, e) => (r) => ({
  type: `DELETE_${c(t)}`,
  id: r,
  payload: {},
  ...e
}), V = (t, e) => (r) => ({
  type: `SET_MANY_${t.toUpperCase()}`,
  payload: r,
  ...e
}), v = (t, e) => ({
  get: F(t, e),
  setAll: K(t, e),
  set: J(t, e),
  add: B(t, e),
  patch: X(t, e),
  delete: Z(t, e),
  setMany: V(t, e)
}), W = (t, e) => (r = {}) => ({
  type: `GET_${t.toUpperCase()}`,
  payload: r,
  ...e
}), x = (t, e) => (r) => ({
  type: `SET_${t.toUpperCase()}`,
  payload: r,
  ...e
}), N = (t, e) => (r) => ({
  type: `ADD_${c(t)}`,
  payload: {
    ...r
  },
  ...e
}), m = (t, e) => (r, s) => ({
  type: `SET_${c(t)}`,
  id: r,
  payload: {
    ...s
  },
  ...e
}), tt = (t, e) => (r, s) => ({
  type: `PATCH_${c(t)}`,
  id: r,
  payload: {
    ...s
  },
  ...e
}), et = (t, e) => (r) => ({
  type: `DELETE_${c(t)}`,
  id: r,
  payload: {},
  ...e
}), rt = (t, e) => (r) => ({
  type: `SET_MANY_${t.toUpperCase()}`,
  payload: r,
  ...e
}), st = (t, e) => (r, s) => ({
  type: `GET_${t.toUpperCase()}_ITEMS`,
  id: r,
  payload: {
    ...s
  },
  ...e
}), pt = (t, e) => (r, s) => ({
  type: `SET_${t.toUpperCase()}_ITEMS`,
  id: r,
  payload: {
    items: s
  },
  ...e
}), ct = (t, e) => (r, s) => ({
  type: `PUSH_${t.toUpperCase()}_ITEM`,
  id: r,
  payload: {
    items: [s]
  },
  ...e
}), _t = (t, e) => (r) => ({
  type: `POP_${t.toUpperCase()}_ITEM`,
  id: r,
  payload: {},
  ...e
}), ot = (t, e) => (r, s) => ({
  type: `DELETE_${t.toUpperCase()}_ITEM`,
  id: r,
  itemId: s,
  payload: {},
  ...e
}), nt = (t, e) => (r, s, p) => ({
  type: `PATCH_${t.toUpperCase()}_ITEM`,
  id: r,
  itemId: s,
  payload: {
    ...p
  },
  ...e
}), Et = (t, e) => (r) => ({
  type: `CLEAR_${t.toUpperCase()}_ITEMS`,
  id: r,
  payload: {},
  ...e
}), ut = (t, e) => (r, s) => ({
  type: `PUSH_MANY_${t.toUpperCase()}_ITEMS`,
  id: r,
  payload: {
    items: s
  },
  ...e
}), it = (t, e) => ({
  get: W(t, e),
  setAll: x(t, e),
  set: m(t, e),
  add: N(t, e),
  patch: tt(t, e),
  delete: et(t, e),
  setMany: rt(t, e),
  getItems: st(t, e),
  setItems: pt(t, e),
  pushItem: ct(t, e),
  patchItem: nt(t, e),
  deleteItem: ot(t, e),
  popItem: _t(t, e),
  clearItems: Et(t, e),
  pushManyItems: ut(t, e)
}), at = (t) => {
  let e = {};
  const r = Object.keys(t);
  for (const s of r) {
    const p = t[s];
    switch (i(p)) {
      case n.SINGLE_NODE:
        e[s] = R(String(s), T);
        break;
      case n.QUEUE_NODE:
        e[s] = z(String(s), T);
        break;
      case n.COLLECTION_NODE:
        e[s] = v(String(s), T);
        break;
      case n.GROUPED_LIST_NODE:
        e[s] = it(String(s), T);
        break;
    }
  }
  return e;
}, Tt = (t) => (e = {}, r) => {
  switch (r.type) {
    case `SET_${t.toUpperCase()}`:
      return { ...r.payload };
    case `PATCH_${t.toUpperCase()}`:
      return { ...e, ...r.payload };
    default:
      return e != null ? e : {};
  }
}, lt = (t) => (e = [], r) => {
  var p;
  let s;
  switch (r.type) {
    case `SET_${t.toUpperCase()}`:
      return { ...r.payload };
    case `PUSH_${c(t)}`:
      return [...e, r.payload];
    case `POP_${c(t)}`:
      return s = [...e], s.pop(), s;
    case `CLEAR_${t.toUpperCase()}`:
      return [];
    case `PUSH_MANY_${t.toUpperCase()}`:
      const { items: _ = [] } = (p = r.payload) != null ? p : {};
      return [...e, ..._ != null ? _ : []];
    default:
      return e != null ? e : [];
  }
}, yt = (t) => {
  const e = (s = {}, p) => {
    switch (p.type) {
      case `SET_${c(t)}`:
        return { ...p.payload };
      case `PATCH_${c(t)}`:
        return {
          ...s,
          ...p.payload
        };
      default:
        return s;
    }
  };
  return (s = {}, p) => {
    let _;
    const { id: o } = p;
    switch (p.type) {
      case `SET_${t.toUpperCase()}`:
        return p.payload;
      case `SET_${c(t)}`:
      case `PATCH_${c(t)}`:
        return o ? {
          ...s,
          [o]: e(s[o], p)
        } : s;
      case `DELETE_${c(t)}`:
        return o ? (_ = { ...s }, delete _[o], _) : s;
      case `SET_MANY_${t.toUpperCase()}`:
        return {
          ...s,
          ...p.payload
        };
      default:
        return s != null ? s : {};
    }
  };
}, Ct = (t) => {
  const e = (p = [], _) => {
    var C;
    let o;
    const { itemId: E } = _, { items: l = [] } = (C = _.payload) != null ? C : {}, y = { ..._.payload };
    switch (_.type) {
      case `SET_${t.toUpperCase()}_ITEMS`:
        return l;
      case `PUSH_${t.toUpperCase()}_ITEM`:
      case `PUSH_MANY_${t.toUpperCase()}_ITEMS`:
        const a = l.map((u) => u.id), $ = [...p].filter((u) => !a.includes(u.id));
        return $.push(...l), $;
      case `POP_${t.toUpperCase()}_ITEM`:
        return o = [...p], o.pop(), o;
      case `DELETE_${t.toUpperCase()}_ITEM`:
        return o = [...p], o.filter((u) => u.id !== E);
      case `PATCH_${t.toUpperCase()}_ITEM`:
        return o = [...p], delete y.id, o.map((u) => u.id !== E ? u : {
          ...u,
          ...y
        });
      case `CLEAR_${t.toUpperCase()}_ITEMS`:
        return [];
      default:
        return p != null ? p : [];
    }
  }, r = (p = {}, _) => {
    switch (_.type) {
      case `SET_${c(t)}`:
        return { ..._.payload };
      case `PATCH_${c(t)}`:
        return {
          ...p,
          ..._.payload
        };
      case `SET_${t.toUpperCase()}_ITEMS`:
      case `PUSH_${t.toUpperCase()}_ITEM`:
      case `POP_${t.toUpperCase()}_ITEM`:
      case `DELETE_${t.toUpperCase()}_ITEM`:
      case `PATCH_${t.toUpperCase()}_ITEM`:
      case `CLEAR_${t.toUpperCase()}_ITEMS`:
      case `PUSH_MANY_${t.toUpperCase()}_ITEMS`:
        return {
          ...p,
          items: e(p.items, _)
        };
      default:
        return p;
    }
  };
  return (p = {}, _) => {
    let o;
    const { id: E } = _;
    switch (_.type) {
      case `SET_${t.toUpperCase()}`:
        return { ..._.payload };
      case `SET_${c(t)}`:
      case `PATCH_${c(t)}`:
      case `SET_${t.toUpperCase()}_ITEMS`:
      case `PUSH_${t.toUpperCase()}_ITEM`:
      case `POP_${t.toUpperCase()}_ITEM`:
      case `DELETE_${t.toUpperCase()}_ITEM`:
      case `PATCH_${t.toUpperCase()}_ITEM`:
      case `CLEAR_${t.toUpperCase()}_ITEMS`:
      case `PUSH_MANY_${t.toUpperCase()}_ITEMS`:
        return E ? {
          ...p,
          [E]: r(p[E], _)
        } : p;
      case `DELETE_${c(t)}`:
        return E ? (o = { ...p }, delete o[E], o) : p;
      case `SET_MANY_${t.toUpperCase()}`:
        return {
          ...p,
          ..._.payload
        };
      default:
        return p != null ? p : {};
    }
  };
}, At = (t) => {
  let e = {};
  const r = Object.keys(t);
  for (const s of r)
    switch (i(t[s])) {
      case n.SINGLE_NODE:
        e[s] = Tt(String(s));
        break;
      case n.QUEUE_NODE:
        e[s] = lt(String(s));
        break;
      case n.COLLECTION_NODE:
        e[s] = yt(String(s));
        break;
      case n.GROUPED_LIST_NODE:
        e[s] = Ct(String(s));
        break;
    }
  return e;
};
export {
  n as NodeType,
  $t as analyzeStructure,
  Ut as clearNodes,
  v as collection_all,
  St as generateActionTypesDictionaryForStore,
  f as generateActionTypesForStore,
  at as generateActionsForStore,
  yt as generateCollection,
  At as generateReducersForStore,
  Tt as generateSingle,
  i as nodeToType,
  R as single_all,
  c as toSingularAction
};
//# sourceMappingURL=redux-store-generator.es.js.map
